<template>
  <el-main>
    <el-row>
      <el-col :span="12">
        <label>input A</label>
      </el-col>
      <el-col :span="12">
        <label>input B</label>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="12">
        <el-input type="textarea" placeholder="" :rows="10" v-model="inputA"></el-input>
      </el-col>
      <el-col :span="12">
        <el-input type="textarea" placeholder="" :rows="10" v-model="inputB"></el-input>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="2" :offset="9">
        <el-select v-model="exec_type">
          <el-option label="和集合(A or B)"               value="union"></el-option>
          <el-option label="積集合(A and B)"              value="intersection"></el-option>
          <el-option label="差集合(A - B)"                value="diff1"></el-option>
          <el-option label="差集合(B - A)"                value="diff2"></el-option>
          <el-option label="対称差集合(A - B) or (B - A)" value="symmetricDiff"></el-option>
        </el-select>
      </el-col>
      <el-col :span="2" :offset="2">
        <el-button @click="execute" type="primary" round>実行！</el-button>
      </el-col>
    </el-row>
    <el-row>
      <el-col :span="12">
        <label>output</label>
      </el-col>
      <el-col :span="24">
        <el-input type="textarea" placeholder="" :rows="10" v-model="output"></el-input>
      </el-col>
    </el-row>
  </el-main>

</template>

<script>
export default {
  data() {
    return {
      inputA: "",
      inputB: "",
      exec_type: "union",
      output: "",
    }
  },
  methods: {
    text2array(text) {
        return text.split("\n").filter((line) => line.length)
    },

    execute() {
        const setA = new Set(this.text2array(this.inputA))
        const setB = new Set(this.text2array(this.inputB))
        let result

        switch(this.exec_type) {
        case "union":
            result = new Set(setA)
            for (let e of setB) {
                result.add(e)
            }
            break
        case "intersection":
            result = new Set()
            for (let e of setA) {
                if (setB.has(e)) result.add(e)
            }
            break
        case "diff1":
            result = new Set(setA)
            for (let e of setB) {
                result.delete(e)
            }
            break
        case "diff2":
            result = new Set(setB)
            for (let e of setA) {
                result.delete(e)
            }
            break
        case "symmetricDiff":
            result = new Set(setA)
            for (let e of setB) {
                if (result.has(e)) {
                    result.delete(e)
                } else {
                    result.add(e)
                }
            }
        }

        this.output = [...result].join("\n")
    },
  }
}
</script>
